//**************************
// find
//  ꤵ줿ͤõ
//**************************

#include <iostream>
#include <algorithm> // find
using namespace std; // 

int main()
{
	int n[5] = { 30, 20, 40, 10, 50 };
	int key = 40;

	int *pos = find(n, n+5, key); // find(ǽ,Ǹ+1,õʪ)
	                              // ɥ쥹֤äƤ롣
	if (pos==n+5) { // ĤʤϡֺǸΥɥ쥹+1
		cout << key << " ϸĤޤ" << endl;
	}
	else { // Ĥä
		// pos Ƭɥ쥹вܤ狼
		cout << key << "  " << (pos-n) << " " << endl;
	}
	return 0;
}

//**************************
// count
//  ꤵ줿ͤõ
//**************************

#include <iostream>
#include <algorithm> // count
using namespace std; //

int main()
{
	int n[10] = { 1, 2, 3, 4, 3, 2, 3, 1, 1, 2 };
	int key = 1;
	int c = count(n, n+10, key); // count(ǽ,Ǹ+1,ʪ)

	cout << key << "  " << c << " Ĥޤ" << endl;

	return 0;
}

//**************************
// random_shuffle
//  ꤵ줿ϰϤ򥷥åե
//**************************

#include <iostream>
#include <algorithm> // random_shuffle
using namespace std; // 

int main()
{
	int n[5] = { 10, 20, 30, 40, 50 };

	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 10 20 30 40 50

	random_shuffle(n, n+5); // 
	                        // random_shuffle(Ƭ, Ǹ)

	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 50 20 40 30 10 (̤ϰ)

	return 0;
}

//**************************
// reverse
//  ꤵ줿ϰϤž
//**************************

#include <iostream>
#include <algorithm> // reverse
using namespace std; // 

int main()
{
	int n[5] = { 10, 20, 30, 40, 50 };

	reverse(n, n+5); // ȿž
	                 // reverse(Ƭ, Ǹ)
	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 50 40 30 20 10

	return 0;
}

//**************************
// rotate
// ꤵ줿ϰϤꤵ줿Ȥޤǲž
//**************************

#include <iostream>
#include <algorithm> // rotate
using namespace std; // 

int main()
{
	int n[5] = { 10, 20, 30, 40, 50 };

	rotate(n, n+3, n+5); // ˲ž
	                     // rotate(Ƭ, Ƭ, Ǹ)
	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 40 50 10 20 30

	return 0;
}

//**************************
// replace
//  ֤ͤ
//**************************

#include <iostream>
#include <algorithm> // replace
using namespace std; // 

int main()
{
	int n[5] = { 1, 2, 1, 2, 1 };

	replace(n, n+5, 1, 10); // ֤
  // replace(ǽ,Ǹ,񤭴,)

	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 10 20 10 2 10

	return 0;
}

//**************************
// fill
//  ͤĤ
//**************************

#include <iostream>
#include <algorithm> // fill
using namespace std; // 

int main()
{
	int n[5];
	fill(n, n+5, 10); // 10
                    // fill(Ƭ,Ǹ,)

	for (int i=0; i < 5; ++i) cout << n[i] << " ";
	cout << endl;
	// 10 10 10 10 10

	return 0;
}

//**************************
// next(prev)_permutation
//  ()ν
//**************************
#include <iostream>
#include <algorithm> // next(prev)_permutation)
using namespace std; //

int main()
{
	int n[3] = { 1, 2, 3 };

	cout << "--- next_permutation ---" << endl;
	for (int i=0; i < 1*2*3; ++i) {
		cout << n[0] << " " << n[1] << " " << n[2] << endl;
		next_permutation(n, n+3); // (Ƭ,Ǹ)
	}

	cout << "--- prev_permutation ---" << endl;
	for (int i=0; i < 1*2*3; ++i) {
		cout << n[0] << " " << n[1] << " " << n[2] << endl;
		prev_permutation(n, n+3); // (Ƭ,Ǹ)
	}
	return 0;
}
/*
// 
--- next_permutation ---
1 2 3
1 3 2
2 1 3
2 3 1
3 1 2
3 2 1
--- prev_permutation ---
1 2 3
3 2 1
3 1 2
2 3 1
2 1 3
1 3 2
*/


//**************************
// for_each
//  Ǥ˴ؿŬ
//**************************

#include <iostream>
#include <algorithm> // replace
using namespace std; // 

// & ϻȤȤʪ
// ̣Ĵ٤ƤߤƤ
void plus10(int &n)
{
	n += 10;
}

void print(int n)
{
	cout << n << " ";
}

int main()
{
	int n[5] = { 1, 2, 3, 4, 5 };

	for_each(n, n+5, plus10); // 10­
                            // for_each(Ƭ,Ǹ,ƤӽФؿ)
	for_each(n, n+5, print); // 
	cout << endl;

	return 0;
}
